#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <string.h>
//#include <signal.h>
//#include <errno.h>
//#include <unistd.h>
//#include <fcntl.h>
//#include <sys/types.h>
//#include <sys/socket.h>
//#include <netinet/in.h>>
//#include <dirent.h>
//#include <sys/wait.h>

int main(int argc, char *argv[])
{
  int sd, fd_sorg, fd_dest, num1;
  struct hostent *host;
  struct sockaddr_in servaddr;
  /** Controllo argomenti - client serverAddr serverPort **/
  if(argc!=3){
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }
  num1=0;
  while( argv[2][num1]!= '\0' ){
    if( (argv[2][num1] < '0') || (argv[2][num1] > '9') ){
      printf("Secondo argomento non intero\n");
      exit(2);
    }
    num1++;
  }
  /****/

  /** Creazione socket **/
  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  if ((host = gethostbyname(argv[1])) == NULL){
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(1);
  }  
  servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
  servaddr.sin_port = htons(atoi(argv[2]));
	if((sd=socket(AF_INET, SOCK_STREAM, 0))<0){
	  perror("apertura socket");
   	exit(1);
  }
  if(connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr))<0){
	  perror("connect");
	  exit(1);
	}
  printf("Client: ON\n");
	/****/
	
	/** Corpo del client **/
	  //scrittura su socket
  char dirName[FILENAME_MAX+1];
  int everRead;
  while(1){
    everRead=0;
    printf("Quale direttorio vuoi copiare? invio per terminare\n");
    num1=0;
    while(1){
          if((dirName[num1++] = getchar()) =='\n') break;
    }
    dirName[--num1]='\0';
    if(strlen(dirName)==0) break;
    write(sd,&dirName,strlen(dirName)+1);    
    //ciclo ricezione file
    char nomeFile[FILENAME_MAX+1],c;
    int fileSize,letti;
    FILE* file;
    while(1){
      num1=0;
      bzero(nomeFile,FILENAME_MAX+1);
      while(1){
          read(sd,&c,sizeof(char));
          nomeFile[num1]=c;
          if(c=='\0') break;
          num1++;
      }
      //ricezione dimensione
      if( read(sd,&fileSize,sizeof(int)) < 0){
        perror("Lettura dimensione file");
        break;
      }
      fileSize = ntohl(fileSize);
      if(fileSize<0){
        if(everRead==0) printf("Directory inesistente!\n");
        break;
      }
      everRead=1;
      /** Inserire qui il protocollo di comuncazione **/
      //creo il file di nome nomeFile
      if( (file=fopen(nomeFile,"w")) < 0 ){
        perror("Creazione file");
        break;
      }
      
      //ricevo fileSize byte e li scrivo nel file
      for(num1=0;num1<fileSize;num1++){
        if( read(sd,&c,sizeof(char)) < 0 ){
          perror("Lettura da socket");
          break;
        }
        if( (fputc(c,file)) < 0 ){
          perror("Scrittura su file");
          break;
        }
      }
      /****/
      close(file);
    }
  }
    //chiusura socket in ricezione
  shutdown(sd,1);
  shutdown(sd, 0);
  /****/
  printf("Client: OFF\n");
  exit(0);
}

